---
title: <translation-value>
slug: Web/CSS/translation-value
tags:
  - CSS
  - CSS Data Type
  - CSS Transforms
  - Data Type
  - Reference
---
<div>{{CSSRef}}</div>

<p>The <strong><code>&lt;translation-value&gt;</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Types">data type</a> is used in the arguments for certain {{cssxref("transform")}} functions, including <code><a href="/en-US/docs/Web/CSS/transform-function/translate">translate()</a></code>, <code><a href="/en-US/docs/Web/CSS/transform-function/translateX">translateX()</a></code>, <code><a href="/en-US/docs/Web/CSS/transform-function/translateY">translateY()</a></code>, and <code><a href="/en-US/docs/Web/CSS/transform-function/translate3d">translate3d()</a></code>.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>&lt;translation-value&gt;</code> data type can be either a {{Cssxref("&lt;length&gt;")}} value or a {{Cssxref("&lt;percentage&gt;")}} value.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Translation_function_comparison">Translation function comparison</h3>

<p>The following example provides a 3D cube created from DOM elements and transforms, and a select menu allowing you to choose different translation-related transform functions to transform the cube with, so you can compare the effects of the different types.</p>

<p>Choose one, and the transform is applied to the cube; after 2 seconds, the cube reverts back to its starting state. The cube's starting state is slightly rotated using <code>transform3d()</code>, to allow you to see the effect of all the transforms.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;main&gt;
  &lt;section id="example-element"&gt;
      &lt;div class="face front"&gt;1&lt;/div&gt;
      &lt;div class="face back"&gt;2&lt;/div&gt;
      &lt;div class="face right"&gt;3&lt;/div&gt;
      &lt;div class="face left"&gt;4&lt;/div&gt;
      &lt;div class="face top"&gt;5&lt;/div&gt;
      &lt;div class="face bottom"&gt;6&lt;/div&gt;
  &lt;/section&gt;

  &lt;div class="select-form"&gt;
    &lt;label&gt;Select a transform function&lt;/label&gt;
    &lt;select&gt;
      &lt;option selected&gt;Choose a function&lt;/option&gt;
      &lt;option&gt;translate(100px, 100px)&lt;/option&gt;
      &lt;option&gt;translateX(100px)&lt;/option&gt;
      &lt;option&gt;translateY(100px)&lt;/option&gt;
      &lt;option&gt;translateZ(100px)&lt;/option&gt;
      &lt;option&gt;translate3d(50px, 50px, 50px)&lt;/option&gt;
    &lt;/select&gt;
  &lt;/div&gt;
&lt;/main&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">main {
  width: 400px;
  height: 200px;
  padding: 50px;
  background-image: linear-gradient(135deg, white, cyan, white);
}

#example-element {
  width: 100px;
  height: 100px;
  transform-style: preserve-3d;
  transition: transform 1.5s;
  transform: rotate3d(1, 1, 1, 30deg);
}

.face {
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100%;
  position: absolute;
  backface-visibility: inherit;
  font-size: 60px;
  color: #fff;
}

.front {
    background: rgba(90,90,90,.7);
    transform: translateZ(50px);
}

.back {
    background: rgba(0,210,0,.7);
    transform: rotateY(180deg) translateZ(50px);
}

.right {
  background: rgba(210,0,0,.7);
  transform: rotateY(90deg) translateZ(50px);
}

.left {
  background: rgba(0,0,210,.7);
  transform: rotateY(-90deg) translateZ(50px);
}

.top {
  background: rgba(210,210,0,.7);
  transform: rotateX(90deg) translateZ(50px);
}

.bottom {
  background: rgba(210,0,210,.7);
  transform: rotateX(-90deg) translateZ(50px);
}

.select-form {
  margin-top: 50px;
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">const selectElem = document.querySelector('select');
const example = document.querySelector('#example-element');

selectElem.addEventListener('change', () =&gt; {
  if(selectElem.value === 'Choose a function') {
    return;
  } else {
    example.style.transform = `rotate3d(1, 1, 1, 30deg) ${selectElem.value}`;
    setTimeout(function() {
      example.style.transform = 'rotate3d(1, 1, 1, 30deg)';
    }, 2000)
  }
})</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Translation_function_comparison', '100%', 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Transforms', '#transform-functions', 'The Transform Functions')}}</td>
   <td>{{Spec2('CSS3 Transforms')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.transform-function")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("transform")}}</li>
</ul>
